models/Ocupan.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "ocupan".
 *
 * @property int $idocupan
 * @property string $matricula
 * @property int $idplaza
 *
 * @property Plazas $plaza
 * @property Vehiculos $matricula0
 * @property Ocupanfechas[] $ocupanfechas
 */
class Ocupan extends \yii\db\ActiveRecord
{
    public $fechaentrada;
    public $fechasalida;
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'ocupan';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['idplaza'], 'integer'],
            [['matricula'], 'string', 'max' => 10],
            [['matricula', 'idplaza'], 'unique', 'targetAttribute' => ['matricula', 'idplaza']],
            [['idplaza'], 'exist', 'skipOnError' => true, 'targetClass' => Plazas::className(), 'targetAttribute' => ['idplaza' => 'idplaza']],
            [['matricula'], 'exist', 'skipOnError' => true, 'targetClass' => Vehiculos::className(), 'targetAttribute' => ['matricula' => 'matricula']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'idocupan' => 'Idocupan',
            'matricula' => 'Matricula',
            'idplaza' => 'Idplaza',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPlaza()
    {
        return $this->hasOne(Plazas::className(), ['idplaza' => 'idplaza']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getMatricula0()
    {
        return $this->hasOne(Vehiculos::className(), ['matricula' => 'matricula']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getOcupanfechas()
    {
        return $this->hasMany(Ocupanfechas::className(), ['idocupan' => 'idocupan']);
    }
}

controllers/OcupanController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Ocupan;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * OcupanController implements the CRUD actions for Ocupan model.
 */
class OcupanController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Ocupan models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Ocupan::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Ocupan model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }
    public function actionListar($matricula){
        
        //todos los datos de las plazas que el vehiculo a utilizado
        $dataProvider = new ActiveDataProvider([
            'query' => Ocupan::find()->select('*')->where("matricula='$matricula'"),
        ]);
        
        // todos los datos del vehiculo
        $vehiculo= \app\models\Vehiculos::findOne($matricula);

        return $this->render('listar', [
            'dataProvider' => $dataProvider,
            'vehiculo'=>$vehiculo,
        ]);
    }

    /**
     * Creates a new Ocupan model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Ocupan();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->idocupan]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Ocupan model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->idocupan]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Ocupan model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Ocupan model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Ocupan the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Ocupan::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/OcupanfechasController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Ocupanfechas;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * OcupanFechasController implements the CRUD actions for OcupanFechas model.
 */
class OcupanfechasController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all OcupanFechas models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Ocupanfechas::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }
    
    public function actionMostrar($id)
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Ocupanfechas::find()->where("idocupan=$id"),
        ]);

        return $this->render('index_1', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single OcupanFechas model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new OcupanFechas model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new OcupanFechas();
                echo "<pre>";
        var_dump(Yii::$app->request->post());
        echo "</pre>";

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->idocupanfechas]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /*
     * public function actionCreate1($id)
     * consulta cruzada ocupan -> ocupanfechas
     
    {
        $model = new OcupanFechas();
        $model->idocupan=$id;
                
        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->idocupanfechas]);
        }
        
        return $this->render('create1', [
            'model' => $model,
        ]);
    }
    */
    
    /**
     * Updates an existing OcupanFechas model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);


        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->idocupanfechas]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing OcupanFechas model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the OcupanFechas model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return OcupanFechas the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Ocupanfechas::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    public function actionListarfechas($idocupan){
        $dataProvider = new ActiveDataProvider([
            'query' => Ocupanfechas::find()->select('*')->where("idocupan=$idocupan"),
        ]);
        
        $plaza = \app\models\Ocupan::findOne($idocupan);
        
        return $this->render('listarfechas', [
            'dataProvider' => $dataProvider,
            'plaza'=>$plaza,
        ]);
        
    }
    
    
}

views/ocupan/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Ocupan */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="ocupan-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'matricula')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'idplaza')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/ocupan/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Ocupan */

$this->title = 'Create Ocupan';
$this->params['breadcrumbs'][] = ['label' => 'Ocupans', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="ocupan-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/ocupan/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Ocupans';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="ocupan-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Ocupan', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'idocupan',
            'matricula',
            'idplaza',

            [
            'class' => 'yii\grid\ActionColumn',
            'template' => '{view} {update} {delete} {mostrar}',
            'buttons' => [
                'mostrar' => function ($url,$model) {
                    return Html::a('<span class="glyphicon glyphicon-road"></span>', ['ocupanfechas/mostrar', 'id' => $model->idocupan]); 
                },
	        ],
            ],
        ],
    ]); ?>


</div>

views/ocupan/listar.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

// $dataProvider->models[0]->matricula0 es igual que $vehiculo

$this->title = 'Datos Vehículo ' . $vehiculo->matricula;
/* memoriza la dirección de donde vienes */
$atras=Yii::$app->request->referrer;
/*modifica los breadcrumbs para volver a la página en la que estábamos anteriormente*/
$this->params['breadcrumbs'][] = ['label'=>'Vehículos','url'=>$atras];


$this->params['breadcrumbs'][] = $this->title;
?>
<div class="ocupan-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= DetailView::widget([
        'model' => $vehiculo,
        'attributes' => [
            'matricula',
            'dni',
            'color',
            'modelo',
        ],
    ]) ?>
    
    

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            

            'idocupan',
            //'matricula',
            //'matricula0.color',
            'idplaza',
            //'fechaentrada',
            //'fechasalida',
            //'plaza.numeroplaza',

            [
            'class' => 'yii\grid\ActionColumn',
            'template' => '{mostrar}',
            'buttons' => [
                'mostrar' => function ($url,$model) {
                    return Html::a('<span class="glyphicon glyphicon-road"></span>', ['ocupanfechas/listarfechas', 'idocupan' => $model->idocupan]); 
                    //return Html::a('<span class = "glyphicon glyphicon-list-alt"></span>',['ocupan/listar','matricula'=>$model->matricula]);
                },
	        ],
            ],
        ],
    ]); ?>


</div>

views/ocupan/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Ocupan */

$this->title = 'Update Ocupan: ' . $model->idocupan;
$this->params['breadcrumbs'][] = ['label' => 'Ocupans', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->idocupan, 'url' => ['view', 'id' => $model->idocupan]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="ocupan-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/ocupan/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Ocupan */

$this->title = $model->idocupan;
$this->params['breadcrumbs'][] = ['label' => 'Ocupans', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="ocupan-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->idocupan], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->idocupan], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'idocupan',
            'matricula',
            'idplaza',
        ],
    ]) ?>

</div>